/*
 * include/asm-arm/hardware/serial_amba2_ioctl.h
 *
 * UART ioctl definitions
 *
 * Copyright 2005,2006,2007 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __SERIAL_AMBA2_IOCTL_H__
#define __SERIAL_AMBA2_IOCTL_H__

#define UART_IOC_MAGIC   'u'

#define UART_IO(num)             _IO  (UART_IOC_MAGIC, num)
#define UART_IOR(num, dataitem)  _IOR (UART_IOC_MAGIC, num, dataitem)
#define UART_IOW(num, dataitem)  _IOW (UART_IOC_MAGIC, num, dataitem)
#define UART_IOWR(num, dataitem) _IOWR(UART_IOC_MAGIC, num, dataitem)

#define AMBAUART_IOC_GETMODE    UART_IOR(1, unsigned long)
#define AMBAUART_IOC_SETMODE    UART_IOW(2, unsigned long)
# define AMBAUART_TX_OFF 0
# define AMBAUART_TX_ON  1

#endif /* __SERIAL_AMBA2_IOCTL_H__ */
