/*
 * include/asm-arm/arch-cxd4115/regs-misc.h
 *
 * MISCCTRL registers
 *
 * Copyright 2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __REGS_MISC_H__
#define __REGS_MISC_H__

#define MISCCTRL_DATA		0x00
#define MISCCTRL_SET		0x04
#define MISCCTRL_CLR		0x08

#define VA_MISCCTRL_DATA(x)	(VA_MISCCTRL(x) + MISCCTRL_DATA)
#define VA_MISCCTRL_SET(x)	(VA_MISCCTRL(x) + MISCCTRL_SET)
#define VA_MISCCTRL_CLR(x)	(VA_MISCCTRL(x) + MISCCTRL_CLR)

#define MISCCTRL_TYPEID		2
# define TYPEID_IDMASK		0xff00
#  define TYPEID_CXD4115	0x0000
#  define TYPEID_CXD9938	0x8000
#  define TYPEID_CXDXXXX	0x0200
#  define TYPEID_CXD4120	0x0100
#define MISCCTRL_XRESETREQ	3

#endif /* __REGS_MISC_H__ */
