/*
 * include/asm-arm/arch-cxd4115/regs-octrl.h
 *
 * OCTRL registers
 *
 * Copyright 2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __REGS_OCTRL_H__
#define __REGS_OCTRL_H__

#define OCTRL_DATA		0x00
#define OCTRL_SET		0x04
#define OCTRL_CLR		0x08

#define VA_OCTRL_DATA(x)	(VA_OCTRL(x) + OCTRL_DATA)
#define VA_OCTRL_SET(x)		(VA_OCTRL(x) + OCTRL_SET)
#define VA_OCTRL_CLR(x)		(VA_OCTRL(x) + OCTRL_CLR)

#define OCTRL64_PIN_ATA		0x00000004
#define OCTRL64_RCV_ATA		0x00000002
#define OCTRL64_DRV_ATA		0x00000001

#define OCTRL324_PCI_XRESET_OE	0x00000004
#define OCTRL324_PCI_XGNTTS_OE	0x00000002
#define OCTRL324_PCI_CLKOUT_OE	0x00000001

#endif /* __REGS_OCTRL_H__ */
