/*-----------------------------------------------------------------------------
 * sonymisc.h
 *
 * a header file for sonymisc
 *
 * Copyright 2005,2006,2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *---------------------------------------------------------------------------*/
#ifndef __SONYMISC_H__
#define __SONYMISC_H__

#include <linux/blkdev.h>

/*=============================================================================
 *
 * sonymisc-dev's public method.
 *
 *===========================================================================*/
/*=============================================================================
 * SONYMISC API
 *===========================================================================*/
/*-----------------------------------------------------------------------------
 * open( struct inode *inode, struct file *file )
 *-----------------------------------------------------------------------------
 * Summary	: Open method
 *     IN param	: inode	:
 *              : file  :
 *     OUT param: -
 *     Return	: Err (0:OK / -1:NG )
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * release( struct inode *inode, struct file *file )
 *-----------------------------------------------------------------------------
 * Summary	: Close method
 *     IN param	: inode	:
 *              : file  :
 *     OUT param: -
 *     Return	: Err (0:OK / -1:NG )
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * sonymisc_register()
 *-----------------------------------------------------------------------------
 * Summary		: register to sonymisc
 *     IN param	: *dev	: pointer of struct sonymisc_device
 *     OUT param: -	: -
 *     Return	: err	: 0:succeed / -EINVAL:param err
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * sonymisc_deregister()
 *-----------------------------------------------------------------------------
 * Summary		: deregister to sonymisc
 *     IN param	: *dev	: pointer of struct sonymisc_device
 *     OUT param: -	: -
 *     Return	: err	: 0:succeed / -EINVAL:param err
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * sonymisc struct
 *---------------------------------------------------------------------------*/
struct sonymisc_device
{
    char			class;
    int 			minor;
    const char			*name;
    struct file_operations	*fops; /* if use character device use */
    struct gendisk 		*gd;	/* if use block device use */
};

#define DEV_CLASS_CHR	0
#define DEV_CLASS_BLK	1

#ifndef __SONYMISC_C__
extern int sonymisc_register( struct sonymisc_device *dev );
extern int sonymisc_deregister( struct sonymisc_device *dev );
#endif /* __SONYMISC_C__ */

#endif /* __SONYMISC_DEV_H__ */
