/*
 * cxd4132_clock.h
 *
 * CLOCK definitions
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __MACH_CXD4132_INCLUDE_MACH_CXD4132_CLOCK_H
#define __MACH_CXD4132_INCLUDE_MACH_CXD4132_CLOCK_H

struct cxd4132_clk_info {
	unsigned long cpu;
	unsigned long fsp;
	unsigned long twd_MHz, twd_per_tick;
};

#define CXD4132_N_SPEED		(2)
#define CXD4132_SPEED_HI	(0)
#define CXD4132_SPEED_LO	(1)

extern struct cxd4132_clk_info *cxd4132_get_clk_info(void);
extern unsigned long cxd4132_cpuclk(void);
extern unsigned long cxd4132_fspclk(void);
extern unsigned long cxd4132_localtimer_rate(void);
extern void cxd4132_set_speed(unsigned int);
extern unsigned int cxd4132_get_speed(void);

#endif /* __MACH_CXD4132_INCLUDE_MACH_CXD4132_CLOCK_H */
