/*
 * include/asm-arm/arch-cxd4132/regs-bam.h
 *
 * BAM definitions
 *
 * Copyright 2011 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __ARCH_CXD4132_REGS_BAM_H
#define __ARCH_CXD4132_REGS_BAM_H

#define BAM_N_CH		3
#define BAM_MON_CTRL		0x0000
# define BAM_MON_START		1
# define BAM_MON_STOP		0
#define BAM_MODE_SET		0x0004
# define BAM_MODE_MEMCHK	(1 << 29)
# define BAM_CTRLMODE_CPU	(0 << 24)
#define BAM_MON_TGT		0x0008
# define BAM_MON_TGT_SHIFT	4
# define BAM_TGT_DDR		0
# define BAM_TGT_ESRAM0		1
# define BAM_TGT_ESRAM1		2
# define BAM_TGT_NONE		3
#define BAM_INT_STATUS		0x0040
#define BAM_INT_ENABLE		0x0048
# define BAM_INT_CH(x)		(1 << (x)*4)
# define BAM_INT_ALL		0x111

#define BAM_CH_BASE(x)		(0x200+(x)*0x300)
#define BAM_MEMCHK_MSK_IP	0x020
# define BAM_MEMCHK_DDR_MSK_CPU		(1 << 26)
# define BAM_MEMCHK_ESRAM_MSK_CPU	(3 << 24)
#define BAM_MEMCHK_START	0x024
#define BAM_MEMCHK_END	       	0x028
#define BAM_MEMCHK_NG_ID       	0x2c0
#define BAM_MEMCHK_NG_ADDR     	0x2c4

#define BAM_MEMCHK_ALIGN	(16 - 1)

#endif /* __ARCH_CXD4132_REGS_BAM_H */
