/*
 * include/asm-arm/arch-cxd4115/regs-clk.h
 *
 * CXD4115 HSTCTRL registers
 *
 * Copyright 2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __REGS_CLK_H__
#define __REGS_CLK_H__

/* CLKRST */
#define CLKRST_DATA		0x00
#define CLKRST_SET		0x04
#define CLKRST_CLR		0x08

#define VA_CLKRST_DATA(x)	(VA_CLKRST(x) + CLKRST_DATA)
#define VA_CLKRST_SET(x)	(VA_CLKRST(x) + CLKRST_SET)
#define VA_CLKRST_CLR(x)	(VA_CLKRST(x) + CLKRST_CLR)

#define CLKRST_SEL_CKEN		0x022
/* bit off == HIGH freq.,  bit on == LOW freq. */
# define SEL_CKEN_UART(x)	(0x10 << ((x)*4))
#define CXD4132_UART_CLK_HIGH  48000000
#define CXD4132_UART_CLK_LOW   12000000

/* FCS */
#define FCS_BASE		(CXD4132_CLKRST(0) + 0x600)
#define FCS_SIZE		0x200
#define VA_FCS(x)		(VA_CLKRST(0) + (x))
#define FCS_MASKED_STATUS	0x610
#define FCS_INT_ENABLE		0x620
# define FCS_INT_FIN		 0x00000001
#define FCS_CK_STATUS		0x730
# define FCS_BUSY		 0x00000100
# define FCS_AVBHOST_STAT 	 0x00000003
#  define FCS_FULL			  0
#  define FCS_HAVB_FHOST		  1
#  define FCS_HALF			  2

#endif /* __REGS_CLK_H__ */
