/*
 * include/asm-arm/arch-cxd4132/regs-sio.h
 *
 * SIO registers
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __REGS_SIO_H__
#define __REGS_SIO_H__

#define SIO_SHIFT 24
#define SIOCS	0x00
# define SIOCS_CSEL (1 << 24)
# define SIOCS_OE   (1 << 25)
# define SIOCS_LMS  (1 << 26)
# define SIOCS_SOEN  (1 << 27)
# define SIOCS_SCKOE (1 << 28)
# define SIOCS_SIOST (1 << 29)
# define SIOCS_CLOE  (1 << 30)
# define SIOCS_ICLSIO (1 << 31)
#define SIOM	0x04
# define SIOM_CSOMOD (1 << 24)
# define SIOM_RTMOD (1 << 25)
# define SIOM_ICK_16 (0 << 26)
# define SIOM_TRM_SENDREC (3 << 28)
# define SIOM_IMOD (1 << 30)
# define SIOM_CSEN (1 << 31)
#define SIOSA	0x08
#define SION	0x0c
#define SIOEN	0x10
# define SIOEN_EN (1 << 24)
#define SIOBGC0	0x14
#define SIOBGC1	0x18
#define SIOBUF  0x100
#endif /* __REGS_SIO_H__ */
