/*
 * include/asm-arm/arch-cxd4132/uart.h
 *
 * UART definitions
 *
 * Copyright 2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __ARCH_CXD4115_UART_H
#define __ARCH_CXD4115_UART_H

#define UART_NR			3
#define UART_DEV_NAME          "cxd4132-uart"

/* register definitions */
#define AMBAUART_RTO		0x1c	 /*  Receive timeout register */
#define UART_RTO_CHAR(x)	((x) * 8 * 16 - 1) /* RTO is (x)*8 bits-time */
#define UART_RTO_DEFAULT	32

/* bit definitions */
#define AMBAUART_CR_SIRINV	0x08

struct uart_platform_data {
	int chan;
	int fifosize;
	char *clock;
};

#define AMBAUART_SOFTIRQ(x)	raise_irq(0, (x))
/* Interrupt to CPU#0 only */

#endif /* __ARCH_CXD4115_UART_H */
