/*
 * arch/arm/mach-cxd4132/sdc-zqcal-api.h
 *
 * SDC ZQ calibration API
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef __ARCH_CXD4132_SDC_ZQCAL_API_H__
#define __ARCH_CXD4132_SDC_ZQCAL_API_H__

#include <linux/udif/macros.h>
#include <linux/udif/proc.h>

extern void sdc_zqcal_init(void);
extern void sdc_zqcal_register(struct sdc_dev_t *dev);
extern void sdc_zqcal_unregister(struct sdc_dev_t *dev);
#ifdef CONFIG_PM
extern void sdc_zqcal_suspend(struct sdc_dev_t *dev);
extern void sdc_zqcal_resume(struct sdc_dev_t *dev);
#endif /* CONFIG_PM */
#ifdef CONFIG_PROC_FS
extern UDIF_SIZE sdc_zqcal_proc_read(UDIF_PROC_READ *proc, UDIF_SIZE off,
				     struct sdc_dev_t *dev);
#endif /* CONFIG_PROC_FS */

#endif /* __ARCH_CXD4132_SDC_ZQCAL_API_H__ */
