/*
 * cxd41xx_cpuid.h
 *
 * CPUID definitions
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef __PLAT_CXD41XX_INCLUDE_MACH_CXD41XX_CPUID_H
#define __PLAT_CXD41XX_INCLUDE_MACH_CXD41XX_CPUID_H

#define CXD41XX_CPUID_UNDEF	0xffffffffUL

#ifndef __ASSEMBLY__
extern unsigned long cxd41xx_cpuid;

#define IS_CXD41XX_CPUID_UNDEF() (CXD41XX_CPUID_UNDEF == cxd41xx_cpuid)

extern void cxd41xx_update_cpuid(void);
#endif /* !__ASSEMBLY__ */

#endif /* __PLAT_CXD41XX_INCLUDE_MACH_CXD41XX_CPUID_H */
