/*
 * arch/arm/plat-cxd41xx/include/mach/gpio.h
 *
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __GPIO_EJ_H__
#define __GPIO_EJ_H__

// function
#define GPIOMODE_GPIO       (0x00000001) // General PORT
#define GPIOMODE_PERIPHERAL (0x00000002) // Peripheral
// Direction
#define GPIOMODE_INPUT      (0x00000004) // Input
#define GPIOMODE_OUTPUT_H   (0x00000008) // Output with High level
#define GPIOMODE_OUTPUT_L   (0x00000010) // Output with Low level

// ioctl command
enum {
	GPIO_CMD_READ = 0,
	GPIO_CMD_WRITE,
	GPIO_CMD_SET_MODE,
	GPIO_CMD_GET_MODE,
};

typedef enum gpio_portctrl{
	GPIO_CTRL_BIT = 0,
	GPIO_CTRL_PORT,
}GPIO_PORTCTRL;

typedef struct gpio_ioctl_port{
	GPIO_PORTCTRL portctl; 	// port contrl flag
	unsigned char portid;  		// Port number
	union{
		unsigned char	bitnum;	// bit number
		unsigned int	bitmask;// bitmask
	};
	unsigned int value;		// set/get value
}GPIO_PORT;

#ifdef __KERNEL__

int gpio_get_mode_bit(unsigned char port, unsigned int bit, unsigned int *mode);
int gpio_set_mode_port(unsigned char port,unsigned int bitmask, unsigned int mode);
int gpio_get_data_port(unsigned char port, unsigned int bitmask, unsigned int *data );
int gpio_set_data_port(unsigned char port, unsigned int bitmask, unsigned int data);

#define gpio_set_mode_bit(port, bit, mode) \
		gpio_set_mode_port(port, (1 << (bit)), mode)
#define gpio_get_data_bit(port, bit, val) 			\
({								\
	int ret = gpio_get_data_port(port, (1 << (bit)), val);	\
	*(val) = (*(val) != 0) ?  1 : 0;			\
	ret;							\
})

#define gpio_set_data_bit(port, bit, val) 			\
	gpio_set_data_port(port, (1 << (bit)), ((val) ? (1 << (bit)) : 0))
#endif

#endif /*__EJ_H__*/
