/*
 * arch/arm/plat-cxd41xx/speed.c
 *
 * Speed notify
 *
 * Copyright 2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#include <linux/module.h>
#include <mach/pm.h>
#include <mach/pm_speed.h>

#undef ELAPSE

void __attribute__((weak)) cxd41xx_speed_notify(void)
{
}

/* Called from DFS interrupt handler */
void pm_speed_notify(void)
{
#ifdef ELAPSE
	unsigned long t1, t2;
	t1 = mach_read_cycles();
#endif /* ELAPSE */

	cxd41xx_speed_notify();
#ifdef ELAPSE
	t2 = mach_read_cycles();
	printk(KERN_ERR "pm_speed_notify: %lu [us]\n", mach_cycles_to_usecs(t2-t1));
#endif /* ELAPSE */
}
EXPORT_SYMBOL(pm_speed_notify);
