/*
 * arch/arm/mach-cxd4115/timer.S
 *
 * TIMER initialize for CXD4115
 *
 * Copyright 2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <linux/linkage.h>
#include <asm/assembler.h>
#include <mach/time.h>
#include <mach/hardware.h>
#include <mach/regs-timer.h>

	.text
ENTRY(timer_init)
	@ TIMER CLK and PCLK are enabled. (default)

	ldr	r0, =CXD4115_TIMER_BASE(TIMER_FOR_SCHED)

	@ already running ?
	ldr	r1, [r0, #CXD4105_TIMERCTL]
	ldr	r2, =CXD4115_TMCK_SCHED_DIV|TMCS_FREERUN|TMST
	cmp	r1, r2
	beq	end

	@ clear sched clock
	mov	r1, #0
	str	r1, [r0, #CXD4105_TIMERCTL]
	mov	r1, #TMCLR|TMINTCLR
	str	r1, [r0, #CXD4105_TIMERCLR]

	@ start sched clock
	ldr	r1, =CXD4115_TMCK_SCHED_DIV|TMCS_FREERUN|TMST
	str	r1, [r0, #CXD4105_TIMERCTL]

 end:
	mov	pc, lr
