/*
 * fs/partitions/sdm_partition_table.h
 *
 * Definitions of the SDM partiton table
 *
 * Copyright 2005,2006 Sony Corporation
 *
 */

#ifndef __SDM_PARTITION_TABLE_H__
#define __SDM_PARTITION_TABLE_H__

#include <linux/types.h>

/* kernel sector size */
#define SECTOR_SHIFT  9  /* 512 bytes */
#define SECTOR_SIZE   (1 << SECTOR_SHIFT)

#define SDM_LABEL_N_PARTITION 30

typedef struct {
	__u32 magic;     /* Magic number */
	__u32 version;
    	__u32 n_partition;
	__u8 spare[20];
	struct sdm_partition {
		__u32 start; /* byte offset */
		__u32 size;  /* byte size */
		__u32 type;
		__u32 flag;
	} __attribute__ ((packed)) partitions[SDM_LABEL_N_PARTITION];
} sdm_partition_tbl;

#define SDM_LABEL_MAGIC		0x36343238
#define SDM_LABEL_VERSION	0x30302e31
/* flag */
#define SDM_LABEL_VALID		0x00000001

#endif /* __SDM_PARTITION_TABLE_H__ */
