/*
 * include/linux/oom_kill.h
 *
 * OOM callback prototype definitions
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __OOM_KILL_H__
#define __OOM_KILL_H__

#ifdef CONFIG_OOM_CALLBACK
extern int before_oom_kill_task(struct task_struct *p);
extern void after_oom_kill_task(struct task_struct *p);
#else
static inline int before_oom_kill_task(struct task_struct *p) { return SIGKILL;}
static inline void after_oom_kill_task(struct task_struct *p) {}
#endif /* CONFIG_OOM_CALLBACK */

#endif /* !__OOM_KILL_H__ */
